*= $0800
!byte $00,$0c,$08,$0a,$00,$9e,$31,$36,$33,$38,$34,$00,$00,$00,$00

;=================================
;Wizards and Warlocks
;---------------------------------
;Written by Richard Bayliss and
;Wayne Womersley

;The concept of this game is to move round
;the maze, avoiding bats and chasing and collecting
;objects before time runs out!

		!to "wizards.prg",cbm ;Convert to C64 destination file 

;Declare variables for game

collision = $03f0 ; Sprite to sprite collision store bytes
objpos = $0370 ; Virtual position for the sprites
sprtpos = $d000 ; Actual position for the sprites
screen = $2800
sync = $0340
animtimer = $02
animdelay = $03
wizardup = $04
wizarddown = $05
wizardleft	= $06
wizardright = $07
bat = $08
playerdir = $09
joyoff = $0c
colcount = $0d
playerY = $71
playerX = $70
batdir1 = $11
batdir2 = $12
batdir3 = $13
batdir4 = $14
randpointer1 = $16
randpointer2 = $17
randpointer3 = $18
randpointer4 = $19
rpointerx = $22
rpointery = $23
randpointer5 = $25
randomobject = $24
currentposx = $25
currentposy = $26
playerscore = $0776
items = $0783
lives = $078c
level = $07af
stage = $27
clock = $0794
;Link binary (.prg files) to their correct allocated addresses

		* = $1000-2
	  	!binary "music.dat" ;Music for game
		* = $2000-2
		!binary "chars.prg" ; Game graphics chars at $2000
		* = $2800-2
		!binary "screen.prg" ;Game level screen at $2800
		* = $3000-2
		!binary "sprites.prg" ;Game sprites at $3000

;Now that all binaries are linked, it is now time for the
;main game assembly code		

		* = $4000 ; Where the game code will lie
		
;Initialize everything, disable IRQ interrupts that are playing
;and then draw the game screen.

		sei
		lda #$00
		sta $d418
		sta randpointer1
		sta randpointer2
		sta randpointer3
		sta randpointer4
		sta randpointer5
		sta rpointerx
		sta randvaluex
		sta randvaluey
		sta animtimer
		sta animdelay
		sta playerdir
		sta joyoff
		sta colcount
		
		
		jsr $ff81
		lda #$00 ;Black background + screen
		sta $d020
		sta $d021
		lda #$00
		sta $d015
		lda #$18
		sta $d018 ;Background multicolour on
		sta $d016
		lda #$0d
		sta $d022
		lda #$0b
		sta $d023
		ldx #$00
greenscreen	lda #$05
		sta $d800,x
		sta $d900,x
		sta $da00,x
		sta $dae8,x
		inx
		bne greenscreen
		lda #1
		sta stage
;put message on to screen
		ldx #$00
showmessage	lda message1,x
		sta $0540-$28,x
		lda message2,x
		sta $0540+$50,x
		lda message3,x
		sta $0540+$a0,x
		lda message4,x
		sta $0540+$f0,x
		lda message5,x
		sta $0540+$140,x
		lda message6,x
		sta $0540+$1b8,x
		
		inx
		cpx #$28
		bne showmessage
firetoplay	lda $dc00
		lsr
		lsr
		lsr
		lsr
		lsr
		bcs firetoplay
		
;Initialize random pointers
		
		lda #$01
		sta batdir1
		lda #$02
		sta batdir2
		lda #$01
		sta batdir3
		lda #$02
		sta batdir4
		
;Copy all the background data from memory
;and paste it to the screen RAM ($0400). Fill colour RAM
;with multicolour green ($D800) (lda #$0d:sta $d800,x+)

		ldx #$00
paintscreen	lda screen,x
		sta $0400,x
		lda screen+$100,x
		sta $0500,x
		lda screen+$200,x
		sta $0600,x
		lda screen+$2e8,x
		sta $06e8,x
		lda #$0d ;	Colour green inside multicolour
		sta $d800,x
		sta $d900,x
		sta $da00,x
		sta $dae8,x
		inx
		bne paintscreen
		

;Set up the sprite objects and starting positions

		lda #$ff
		sta $d015 ;All sprites are switched on
		sta $d01c ;All sprites are multicolour
		lda #$0b
		sta $d025
		lda #$0a
		sta $d026
		lda #$36
		sta clock
		lda #$30
		sta clock+1
		sta clock+2
		sta clock+3
		lda #$30
		sta lives
		lda #$33
		sta lives+1
		lda #$35
		sta items+1
		lda #$30
		sta items
		lda #$31
		sta level+1
		lda #$30
		sta level
		lda #$c5 ;Player's wizard
		sta $07f8
		lda #$0e
		sta $d027
		lda #$0e
		sta objpos+$00
		lda #$c2
		sta objpos+$01
		lda battable
		lda #$00
		sta $d020

;First object is the ring

		lda ring
		sta $07f9
		lda #$03
		sta $d028
		lda #$98
		sta objpos+$02
		sta currentposx
		lda #$44
		sta objpos+$03
		sta currentposy

;Set up the starting position for the bats

		sta $07fa
		sta $07fb
		sta $07fc
		sta $07fd
		sta $07fe
		sta $07ff
		lda #$08
		sta $d02a
		sta $d02b
		sta $d02c
		sta $d02d
		sta $d02e
		sta $d029
		lda #$18	
		sta objpos+$04
		lda #$48
		sta objpos+$05
		lda #$98
		sta objpos+$06
		lda #$88
		sta objpos+$07
		lda #$28
		sta objpos+$08
		lda #$88
		sta objpos+$09
		lda #$98
		sta objpos+$0a
		lda #$48
		sta objpos+$0b
		lda #0
		sta objpos+$0c
		sta objpos+$0d
		sta objpos+$0e
		sta objpos+$0f
		
		
;Now prepare IRQ interrupt 

		sei
		lda #<irq
		ldx #>irq
		sta $0314
		stx $0315
		lda #$7f
		sta $dc0d
		lda #$00
		sta $d012
		lda #$1b
		sta $d011
		lda #$01
		sta $d01a
		lda #$00
		jsr $1000
		cli

;Our main loop starts here

mainloop	lda #$00	;Synchronize the game code
		sta sync	;so that it will work nicely
syncwait	cmp sync	;outside the IRQ raster
		beq syncwait	;interrupt routine.
		jsr expand	;Call expand, to expand sprite area
		jsr animate	;Call routine to animate sprites
	
		jsr readplayer  ;Call routine to control player	
		jsr movebats	;Call rotine
		jsr storecollision	;Call collision store routine
		jsr collectcollision	;Call collision for objects
		jsr enemycollision	;Call collision for enemies
		jsr randomizepos		
		jsr randomizeobjects
		jsr time
		jmp mainloop

;Expand the sprite positions so that they can go further than 255 
;pixels on screen.

expand		ldx #$00
expandloop	lda objpos+$01,x ;Read virtual sprite Y position
		sta $d001,x	 ;Write into actual sprite Y position
		lda objpos+$00,x ;Read virtual sprite X position
		asl        	 ;Increase the field size for   
		ror $d010        ;sprite X position
		sta $d000,x   	 ;Write to actual sprite X position
		inx		 ;Add by 2
		inx
		cpx #$10	 ;Compare to 16
		bne expandloop   ;if not then read expandloop again
		rts		 ;End of routine

;Multi-purpose sprite animator routine

animate	inc animdelay
		lda animdelay
		cmp #$04
		beq mainanim
		rts
mainanim	lda #$00
		sta animdelay
		
		lda playerdir
		beq batanim
		sec
		sbc #$01		
		asl
		asl
		adc animtimer
		tax
		lda wizarduptable,x
		sta $07f8		
		
batanim	ldx animtimer
		lda battable,x
		sta $07fa
		sta $07fb
		sta $07fc
		sta $07fd
		inx
		cpx #$04
		beq resetanim
		inc animtimer
		rts
resetanim	lda #$00
		sta animtimer
		sta animdelay
		rts	



;Call routine to move the player around the screen.

tempjoy	!byte $00
movecount	!byte $00

readplayer	lda joyoff
		beq chkmove
joynoton	rts
		
chkmove	lda movecount	; check if we still move
		bmi doread		; no then check joystick
		beq doread		; no, then check joystick
		
		lda playerdir	; yes, so move player 
		jsr checkmove
		dec movecount	; decrement move counter
		rts		
		
doread	lda #$00
		sta playerdir
		
		lda $dc00		;Allocate joystick port 2
		sta tempjoy
up		and #$01		; check joy up
		bne down
		lda #$01		; move up
		jsr checkmove	; movecount will be set > 0 when move was ok
		lda movecount	; move ok?
		bne nojoy		; yes, jump out here
		
down		lda tempjoy		; check joy down
		and #$02
		bne left
		lda #$02		; move down, same as above
		jsr checkmove
		lda movecount	
		bne nojoy

left		lda tempjoy		; check joy left
		and #$04
		bne right
		lda #$03		; move left, same as above

		jsr checkmove
		lda movecount
		bne nojoy
		
right	lda tempjoy		; check joy right
		and #$08
		bne nojoy
		lda #$04		; move right, same as above
		jsr checkmove
						
nojoy	rts


;--------------------------------------------------

; check/move player 
; input (AKKU):  0=no-move, 1=up, 2=down, 3=left, 4=right


movetab		!byte $00, $fe,$02,$ff,$01
movetabxy	!byte $00, $01,$01,$00,$00		
moveborder 	!byte $00, $40,$c6,$0d,$9e		
moveadjust 	!byte $00, $00,$06,$00,$08
numberofmoves	!byte $00, $01,$01,$01,$01

temp			!byte $00
playerpos  	!byte $00,$00,$00,$00

checkmove		sta playerdir		; store direction of player
		
			lda objpos			; put current x-position in temp vars
			sta playerpos
			sta playerpos+2
			lda objpos+1		; put current y-position in temp vars
			sta playerpos+1
			sta playerpos+3

			ldx playerdir		; get direction in X-register
			ldy movetabxy,x		; find out what needs to be altered and put index in Y-Register (0=players xpos, 1=players ypos)
			lda playerpos,y		; get current pos (x or y)
			clc				; and calculate new position by
			adc movetab,x		; add/substract for movement
			cmp moveborder,x		; check if we reached a border
			bne noborder		; no, then check the background for walls		
stopmove		lda #$00			; yes border, 
			sta movecount		; so stop moving 
			sta playerdir		; and clear direction
moveend		rts
		
noborder		sta playerpos,y		; store pos x or y in temp var
			clc
			adc moveadjust,x		; adjust position according to direction, so we have correct side/column 
			sta playerpos+2,y		; to check (left or right) and store in another temp var

			lda playerpos+3		; calculate row
			sec
			sbc #$32		
			lsr				; divide by 8
			lsr
			lsr
			tay

			lda playerpos+2		; calculate column
			sec
			sbc #$0a		
			lsr				; divide by 4, because sprite xpos is multiplicated with 2
			lsr
			clc
			adc scrlo,y			; calculate screen position
			sta $70
			lda scrhi,y
			adc #$00
			sta $71
				
			cpx #$03			; if it's left or right to move (dir=3 or higher), 
			bcs noaddcheck		; then we do no additional checks because we've calced already correct side
			lda #$03			; if it's up/down we do the loop 3 times for additional checks on columns beside!
			!byte $2c			; normal:  X	additional: XXX
noaddcheck		lda #$00			;          X			XXX
			sta temp			;          X			XXX
		
checkbgnd		ldx #$03			; check the background 
			ldy #$00	
checkbgnd1		lda ($70),y			; read from screen
		
			cmp #$fb			; check if it's a wall
			beq stopmove
			cmp #$fc
			beq stopmove
				
			tya				; check next row
			clc
			adc #$28
			tay
			dex				; loop next row
			bne checkbgnd1

			lda temp			; if it's normal check jump out here
			beq moveok
				
			inc $70			; additional check, so increment screen-pos (column+1)
			bne checkbgnd2		
			inc $71	
		
checkbgnd2		dec temp			; loop if we still need to do some more tests
			lda temp
			bne checkbgnd
				
moveok		lda playerpos		; move is ok, so store our calculated temp vars
			sta objpos			; in the objectpos-table
			lda playerpos+1
			sta objpos+1
		
			ldx playerdir		; get players direction
			beq moveok1			; if no-move, jump out here
			lda movecount		; is movecount zero?
			beq setmovecnt		; yes, then set new move count 
moveok1		rts
		
setmovecnt		lda numberofmoves,x	; get number of moves for that direction 
			sta movecount		; and store it in move counter
			rts		
		



;--------------------------------------------------

;Move those bats according to the direction they are supposed to move

movebats		ldy #$03
movebats01		sty battemp
		
			lda batmovecounter,y	; do we need to move bat?
			beq getnextmove		; no, get next move for that bat
			
			sec				; yes, decrement counter
			sbc #$01
			sta batmovecounter,y	
			ldx batdir,y		; get direction 
			lda batobjpos,y		; and objpos for that bat
			jsr movebat			; then move bat

			ldy battemp			; loop for next bat
			dey
			bpl movebats01
			rts

getnextmove	ldx battemp			; calculate new possible moves
			jsr calcbatpos		
	
			ldx battemp			; get bat number
			lda batpossiblemoves,x	; store possible moves in temp var
			sta battemp+1
				
			ldy batdir,x		; get direction for that bat
			beq findnextmove		; no-move means we have to find a next move
			
			and waypointbitstab,y	; check if we can still move in that direction
			beq findnextmove		; no, then find next move
			
			lda batpossiblecount,x  ; yes, check for intersection
			cmp #$03			; if more than 3 moves possible then its a intersection and not just a corner
			bcc foundmove2		; no, so keep on moving
			
			inc batintersect,x	; yes, but make new decision only every 2nd intersection 
			lda batintersect,x
			and #$01			; 2nd intersection?
			bne foundmove2		; no, keep on moving
			
			lda battemp+1		; yes intersection, remove opposite direction from possible moves
			eor waypointbitstab2,y  ; so it can't choose the way back
			sta battemp+1
		
findnextmove	
			iny				; get some kind of random number/pos					
			tya
			clc
			adc $dc04			
			sbc $dc05
			and #$03
			tay
			
			ldx #$03			; test for possible move
getnextmove1	lda battemp+1
			and waypointbits,y	; is this move possible?
			bne foundmove		; yes, that move is possible
			iny				; no, then try next direction
			dex
			bpl getnextmove1		; loop until we have tested all 4 directions
			rts

foundmove		tya				; convert to direction
			and #$03
			clc
			adc #$01
			ldx battemp
			sta batdir,x		; and store for bat
foundmove2		lda #$04
			sta batmovecounter,x	; let's move the bat for a character (4x2 pixel)
			rts

;=====================================================================
;Player sprite to various sprite collisions
;=====================================================================

storecollision		lda objpos+$00 ;Store all collision pointers
			sec		;to the player.
			sbc #$06
			sta collision+$00
			clc
			adc #$0c
			sta collision+$01
			lda objpos+$01
			sec
			sbc #$0c
			sta collision+$02
			clc
			adc #$18
			sta collision+$03
			rts
;=====================================================================
;Player touches the collectables. Let this take effect
;=====================================================================
nocollect		rts
collectcollision	lda objpos+$02
			cmp collision+$00
			bcc nocollect
			cmp collision+$01
			bcs nocollect
			lda objpos+$03
			cmp collision+$02
			bcc nocollect
			cmp collision+$03
			bcs nocollect
			lda randvaluex
			cmp currentposx
			bne gok
			jsr randomizepos
			lda randvaluex
gok			sta objpos+$02
			sta currentposx
			lda randvaluey
			cmp currentposy
			bne gok2
			jsr randomizepos
			lda randvaluey
gok2			sta objpos+$03
			sta currentposy
			

	
			lda $07f9
			cmp wand
			beq ten
			cmp book
			beq twenty
			cmp ring
			beq thirty
			cmp key
			beq fifty
fifty		jsr score
			jsr score
thirty		jsr score
twenty		jsr score
ten			jsr score
			jsr whatobject
			dec $0784
			lda $0784
			cmp #$2f
			bne notover
			lda #$39
			sta $0784
			dec $0783
notover	lda $0783
			cmp #$30
			bne notover2
			lda $0784
			cmp #$30
			bne notover2
			jmp levelcomplete
notover2

score			inc playerscore+4
			ldx #4
scloop			lda playerscore,x
			cmp #$3a
			bne scok
			lda #$30
			sta playerscore,x
			inc playerscore-1,x
scok			dex
			bne scloop
			rts
			
;Decrease the amount of items that have been picked up
			
			
			
			
levelcomplete 
				inc level+1
				lda level+1
				cmp #$3a
				bne addstage
				inc level+0
				rts
addstage		inc stage
				lda stage
				cmp #2
				beq setstage2
				cmp #3
				beq setstage3
				cmp #4
				beq setstage4
				ldx #$00
welldonemess	lda wdmessage,x
				sta $0400,x
				lda #$07
				sta $d800,x
				inx
				cpx #$28
				bne welldonemess
				ldx #$00
wd1				ldy #$00
wd2				iny
				bne wd2
				inx
				bne wd1
				jmp $4000
				
setstage2		lda #$30
				sta items+1
				lda #$31
				sta items+0
				lda #$35
				sta clock
				lda #$30
				sta clock+1
				sta clock+2
				sta clock+3
				lda #$02
				sta $d023
				lda #$0a
				sta $d022
				rts
setstage3		lda #$30
				sta items+1
				lda #$32
				sta items+0
				lda #$35
				sta clock
				lda #$30
				sta clock+1
				sta clock+2
				sta clock+3
				lda #$06
				sta $d023
				lda #$0e
				sta $d022
				rts
setstage4		lda #$30
				sta items+1
				lda #$35
				sta items+0
				lda #$33
				sta clock+1
				sta clock+2
				sta clock+3
				lda #$09
				sta $d023
				lda #$08
				sta $d022
				rts

				
;Because we have a random counter, check
;to see what the random object on screen
;is

whatobject	
			lda randomobject
			cmp #1
			beq iswand
			cmp #2
			beq isring
			cmp #3
			beq isbook
			cmp #4
			beq iskey
			rts
			
iswand		lda wand
			sta $07f9
			rts
isring		lda ring
			sta $07f9
			rts
isbook		lda book
			sta $07f9
			rts
iskey		lda key
			sta $07f9
			rts
isdoor		lda door
			sta $07f9
			rts
			

			
;=====================================================================
;Player touches the enemy bats or vice-versa. Let this take effect
;=====================================================================

enemycollision		ldx #$00
collisionloop		lda objpos+$04,x
			cmp collision+$00
			bcc notdead
			cmp collision+$01
			bcs notdead
			lda objpos+$05,x
			cmp collision+$02
			bcc notdead
			cmp collision+$03
			bcs notdead
			jmp playerdead
			rts
notdead			inx
			inx
			cpx #$0c
			bne collisionloop
			rts
			
playerdead 		ldx #$00
bb			ldy #$00
aa			inc $d027
			iny
			bne aa
			inx
			bne bb
			dec lives+1
			lda lives+1
			cmp #$30
			beq gameover
		lda #$18	
		sta objpos+$04
		lda #$48
		sta objpos+$05
		lda #$98
		sta objpos+$06
		lda #$88
		sta objpos+$07
		lda #$28
		sta objpos+$08
		lda #$88
		sta objpos+$09
		lda #$98
		sta objpos+$0a
		lda #$48
		sta objpos+$0b
		lda #0
		sta objpos+$0c
		sta objpos+$0d
		sta objpos+$0e
		sta objpos+$0f

			lda #$0e
			sta objpos+$00
			lda #$c2
			sta objpos+$01
			lda #$0e
			sta $d027
			rts
gameover	ldx #$00
showgomess lda gomessage,x
			sta $0400,x
			lda #$02
			sta $d800,x
			inx
			cpx #$28
			bne showgomess
			ldx #$00
go1			ldy #$00
go2			;dec $d020
			iny
			bne go2
			inx
			bne go1
			jmp $4000			

			
		
		
; Move bat according to direction
; input:
;   X: direction -> 0 = no-move  1 = up, 2 = down, 3 = left, 4 = right.
;   A: objpos of bat-sprite in sprite-table


movebat		cpx #$00			; routine to move bat according to direction
			beq batnomove		; 0 = no move, so jump out here
			clc
			adc batmovetabxy,x	; calc position in object-table 
			tay
			lda objpos,y		; get current position 
			clc
			adc batmovetab,x		; add/substract position
			sta objpos,y
batnomove		rts


battemp 		!byte $00,$00,$00
		
batmovetab		!byte $00, $fe,$02,$ff,$01		; add/substract values for dirctions
batmovetabxy	!byte $00, $01,$01,$00,$00		; 0=sprite xpos, 1=sprite ypos


;--------------------------------------------------
batobjpos		!byte $04,$06,$08,$0a

batdir 		!byte $00,$00,$00,$00
batmovecounter	!byte $00,$00,$00,$00	
batintersect	!byte $00,$00,$00,$00

batpossiblemoves	!byte $00,$00,$00,$00
batpossiblecount !byte $00,$00,$00,$00

waypointstartpos	!byte $01,$a1,$28,$2c
waypointadd	!byte $01,$01,$28,$28

waypointbitstab	!byte $00
waypointbits	!byte $01,$02,$04,$08
			!byte $01,$02,$04,$08
			
waypointbitstab2 !byte $00, $02,$01,$08,$04			

batnum = $fb
wpnum = $fc

; calculates screenpos for bat and the possible moves
; input:
;   X: bat number


calcbatpos		stx batnum 			; store bat number
		
			ldy batobjpos,x		; get objpos for sprites
		
			lda objpos+1,y		; calc row based on sprite y-position
			sec
			sbc #$3a			; sbc #$32
			lsr
			lsr
			lsr
			tax
		
			lda objpos,y		; calc column based on sprite x-position
			sec
			sbc #$10			; sbc #$0c
			lsr
			lsr
			clc
			adc scrlo,x			; calculate screen position
			sta $70
			lda scrhi,x
			adc #$00
			sta $71
		
			ldx batnum		
			lda #$00			; clear possible moves
			sta batpossiblemoves,x
			sta batpossiblecount,x
			
			ldx #$03			; calculate possible moves for up/down/left/right
calcwp01		stx wpnum
		
			lda waypointadd,x
			sta wpadd+1
			ldy waypointstartpos,x				
		
			ldx #$03
calcwp00		lda ($70),y			; check if it's a wall
			cmp #$fb
			beq nowaypoint		; yes, no waypoint
			cmp #$fc
			beq nowaypoint		; yes, no waypoint
			tya
			clc
wpadd		adc #$00
			tay
			dex
			bne calcwp00
		
			ldx batnum			; waypoint found, add bit
			inc batpossiblecount,x
			ldy wpnum
			lda batpossiblemoves,x
			ora waypointbits,y
			sta batpossiblemoves,x
						
nowaypoint 	ldx wpnum
			dex
			bpl calcwp01
		
			rts
;Randomize positions according to timer

randomizepos	ldx rpointerx
		lda randxpos,x
		sta randvaluex
		lda randypos,x
		sta randvaluey
		inx
		cpx #15
		beq resetrandom
		inc rpointerx
		rts
resetrandom	ldx #$00
		stx rpointerx
		rts

			


;The main interrupt continuously playing inside the IRQ

irq		asl $d019
		lda $dc0d
		sta $dd0d
		lda #$00
		sta $d012
		lda #$01
		sta sync
		jsr $1003
		
			
		pla
		tay
		pla
		tax
		pla
		rti
		
randomizeobjects:
		ldx randpointer5
		lda randobjs,x
		sta randomobject
		inx
		cpx #4
		beq resetobj
		inc randpointer5
		rts
resetobj:
		ldx #0
		stx randpointer5
		rts
		
;Game playing time 

time	dec clock+3
		ldx #4
clocks	lda clock,x
		cmp #$2f
		bne clockok
		lda #$39
		sta clock,x
		dec clock-1,x
clockok 
		dex
		bne clocks
		lda clock
		cmp #$2f
		beq timeover
		rts
timeover
		lda #$30
		sta clock
		sta clock+1
		sta clock+2
		sta clock+3
		jmp gameover
		

		
;Data tables for the wizard animation

wizarduptable	!byte $ca,$cb,$cc,$cb
wizarddowntable 	!byte $c4,$c5,$c6,$c5
wizardlefttable 	!byte $c1,$c2,$c3,$c2
wizardrighttable !byte $c7,$c8,$c9,$c8
spelltable		!byte $cd,$ce,$cf,$ce

ring		!byte $d0
book		!byte $d1
key		!byte $d2
bomb		!byte $d3
wand		!byte $d4
door		!byte $d5
spider	!byte $da
battable	!byte $dc,$dd,$de,$dd

;Data tables for the sprite/background collision table

scrhi 	!byte $04,$04,$04,$04,$04,$04,$04,$05,$05,$05,$05,$05
		!byte $05,$06,$06,$06,$06,$06,$06,$06,$07,$07,$07,$07,$07,$07
scrlo 	!byte $00,$28,$50,$78,$a0,$c8,$f0,$18,$40,$68,$90,$b8
		!byte $e0,$08,$30,$58,$80,$a8,$d0,$f8,$20,$48,$70,$98,$c0,$e0

randdir1	!byte 1,2,3,4,2,3,1,4,3,1,2,4,1,3,4,3
randdir2	!byte 3,2,1,4,2,4,1,3,1,4,2,1,4,1,3,2
randdir3	!byte 4,1,3,2,4,1,2,3,4,1,2,4,3,2,4,1
randdir4	!byte 2,4,1,4,3,4,2,4,1,4,2,3,2,4,1,4
randobjs	!byte 1,2,3,4,5

;Title screen message

message	!scr "*************************************** "
message1	!scr "              the sorcerer              "
message2	!scr "    programming by richard bayliss      "
message3	!scr "   with technical help by marauder/gss  "
message4	!scr "      graphics by wayne womersley       "
message5	!scr "        music by richard bayliss        "
message6	!scr "           press fire to play           "
gomessage	!scr "                 game over              "
wdmessage	!scr "                 well done              "
randvaluex	!byte $80
randvaluey

;Random X,Y tables for the start sprite position for the objects

randxpos	!byte $48,$80,$38,$18,$48,$18,$80,$38
		!byte $18,$48,$84,$38,$18,$60,$60,$18

randypos	!byte $c4,$a4,$84,$64,$44,$64,$a4,$a4
		!byte $c4,$84,$64,$84,$64,$c4,$44,$c4


		

		


